    program xcobs

    use mkinds
    use mtsclim
    use mobs
    use moisst
!!Alex    use mnavo
    use maviso
    use mdrifter
    use modyssea
    use mcobsio
    use msmos
    use miquam 
    use mzprofiles




    implicit none

    logical(bl)              :: lexist
    integer(i4)              :: iflag
    integer(i4)              :: nptot
    character(10)            :: analysis_date



    call get_command_argument(1,analysis_date)
    call initialize_obs()
    call init_sclim_grid(sclim_data_location)
    call set_l4obs_grid(cnx,cny,clon,clat)
    cobsFile=trim(cobs_location)//analysis_date(1:4)//"/tsis_cobs_"//analysis_date//".nc"
    call write_cobs_file_skel(cobsFile,cnx,cny)
    call process_profiles(analysis_date,nptot)
    if(nptot>0) call cobs_add_profiles(cobsFile,&
                      nptot,  &
                      cnz,     &
                      a_prnum,&
                      cdpth, &
                      a_prlon,    &
                      a_prlat,    &
                      a_prtime,   &
                      a_prtemp,    &
                      a_prsaln,    &
                      a_ctemp,   &
                      a_csaln,   &
                      a_dctemp,   &
                      a_dcsaln,   &
                      a_ctstd,   &
                      a_csstd,   &
                      a_it,      &
                      a_is,      &
                      a_valid,  &
                      a_prtyp)


    call  aviso_l3sla_2cobs(analysis_date,iflag)
    if(iflag==0) then
       call  cobs_add_l3sla(cobsFile,nl3sla,l3sla_lon,l3sla_lat,l3sla_time,l3sla_val,l3sla_err)
    endif

    call aviso_l4sla_2cobs(analysis_date,iflag)
    if(iflag==0) then
          call  cobs_add_l4sla(cobsFile,l4obs_nx,l4obs_ny,l4sla_val,l4sla_err)
    endif


    call iquam_l2isst_2cobs(analysis_date,iflag)
    if(iflag==0) then
         call  cobs_add_l2isst(cobsFile,nl2isst,l2isst_lon,l2isst_lat,l2isst_time,l2isst_val,l2isst_err)
    endif

    call odyssea_l3sst_2cobs(analysis_date,iflag)
    if(iflag==0) then
       call  cobs_add_l3sst(cobsFile,nl3sst,l3sst_lon,l3sst_lat,l3sst_time,l3sst_val,l3sst_err)
    endif
    
    call  oisst_l4sst_2cobs(analysis_date,iflag)
!!Alex    call  navo_l4sst_2cobs(analysis_date,iflag)
    if(iflag==0) then
          call  cobs_add_l4sst(cobsFile,l4obs_nx,l4obs_ny,l4sst_val,l4sst_err,l4ice_cov)
    endif

    call smos2cobs(analysis_date,iflag)
    if(iflag==0) then
     call cobs_add_l2sss(cobsFile,cnx,cny,l2sss_val,l2sss_err)
    endif

    call drifter_2cobs(analysis_date,iflag)
    if(iflag==0) then
       call  cobs_add_drifter(cobsFile,n_drifter,drifter_lon,drifter_lat,drifter_time,drifter_uc,drifter_vc)
    endif






   end program
