program xmgmrf
USE OMP_LIB
use minit
use mminfo
use mncio
use mmgmrf
use mgmrf
use mhycom
use mfld
use mavect
use mlilo
use msproject
use mpost
use mc2r
use mprep


implicit none
integer(i4)   :: k

! inilization
            call initialize_tsis()
            call set_vproject()
! analysis
            call omp_set_num_threads(nl)
            call initInfoPairM(nx,ny,3,1)
            f3(:,:,:,1)=ftem
            f3(:,:,:,2)=fsal
            f3(:,:,:,3)=fpin(:,:,1:nl)
            fathk=fthk
            athk=fthk
              
            if(l3sla) then
              var="l3ssh"
              k=1
              cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              sf3(:,:,1,1)=fuvl(:,:,1)
              sf3(:,:,2,1)=fvvl(:,:,1)
              sf3(:,:,3,1)=fssh
             
              call sobs2mgrid3(analysis_date,pfx,sb3,se3,mdepth)
              call remove_mn(sb3(:,:,3,1),mdepth,nx,ny,spval,"ssh obs mean")
              call setInfoMatrixM(nx,ny,3,1,msk3d(:,:,1))
              call setInfoVectorM(nx,ny,3,1,sb3,sv3)
              call geothin(fcori,mpscx,mpscy,msk3d(:,:,1),nx,ny,1)
              call roifPCGM(si3,nx,ny,3,1,msk3d(:,:,1)) 
              call ncfldio("i3ssh.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),si3(:,:,3,1),"iv","ssh increments","m",nx,ny,1,1)              
              call ncfldio("i3u.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),si3(:,:,1,1),"iv","u increments","m",nx,ny,1,1)
              call ncfldio("i3v.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),si3(:,:,2,1),"iv","v increments","m",nx,ny,1,1)
              call FreeInfopairM() 
              sla_inc=si3(:,:,3,1)
              stop
              if(hproject==0) then
                call lilo(start,count,mdepth,thref,thbase,dp0k,fthk,fden,fmld,sla_inc,athk) 
              else
                call project_hdp(nx,ny,nl,mdepth,fthk,sla_inc,athk)                
              endif        
              call update_pin(athk,fpin,nx,ny,nl)
             endif

              call initInfoPair(nx,ny,nl,3)
              if(l3sst) then
              var="l3sst"
              k=1
              cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              fv=fsst
              call getbvev(analysis_date,pfx,var,bv,ev,k)
              call getvv(var,vv,k)
              call set_bv(var,mdepth,bv,fv,spval)
              call setInfoMatrix(nx,ny,1,1,msk3d(:,:,1))
              call setInfoVector(nx,ny,1,1,bv,vv)
              call roifPCG(iv,nx,ny,1,1,msk3d(:,:,1))
              !call ncfldio("sst.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),iv,"iv","sst increments","degc",nx,ny,1,1)
              sst_inc=iv   ! increments to be stored.
              asst=fsst+iv ! needed for residuals
              call project_sst(nx,ny,nl,mdepth,iv,f3(:,:,:,1),f3(:,:,:,3),fmld) ! use mld and updated pin
              !var="l2sss"
              !k=1
              !cv=0.0;bv=0.0;iv=0.0;ev=0.0;vv=0.0
              !fv=fsss
              !call getbvev(analysis_date,pfx,var,bv,ev,k)
              !call getvv(var,vv,k)
              !call set_bv(var,mdepth,bv,fv,spval)
              !call setInfoMatrix(nx,ny,1,1,msk3d(:,:,1))
              !call setInfoVector(nx,ny,1,1,bv,vv)
              !call roifPCG(iv,nx,ny,1,1,msk3d(:,:,1))
              !call ncfldio("sss.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),iv,"iv","sss increments","",nx,ny,1,1)
             endif

              ! set fvector here to handle no data case
              !f3(:,:,:,1)=ftem ! updated from sst directly
              !f3(:,:,:,2)=fsal
              !f3(:,:,:,3)=fpin ! updated from ssh
              !fathk=fthk
              !athk=fthk
              if(l2profile) then
               call init_pobs(analysis_date,nobs,pfx)
               ivar=1;b3=0.0;i3=0.0;v3=0.0;e3=0.0
               call pobs2mgrid3(nobs,ivar,ilvl,b3,e3,nvalid)
               call setInfoMatrix(nx,ny,nl,3,msk3d)
               call setInfoVector(nx,ny,nl,3,b3,v3)
               call roifPCG(i3,nx,ny,nl,3,msk3d)
               f3(:,:,:,1)=i3(:,:,:,1)+f3(:,:,:,1) ! set fvector for post
               f3(:,:,:,2)=i3(:,:,:,2)+f3(:,:,:,2)
               fpin(:,:,1:nl)=i3(:,:,1:nl,3)+fpin(:,:,1:nl)
               call update_dp(fpin,athk,mdepth,nx,ny,nl) ! update athk
               f3(:,:,:,3)=athk
              endif 
              ! fathk=athk
              ! call ncfldio("sst.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),i3(:,:,6,1),"iv","sst increments","degC",nx,ny,1,1)
              ! call ncfldio("sss.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),i3(:,:,6,2),"iv","sss increments","",nx,ny,1,1)
              ! call ncfldio("pin.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),i3(:,:,9,3),"iv","intf increments","m",nx,ny,1,1)


              !endif
!              call ncfldio("fssh.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),fssh,"fssh","ssh increments","m",nx,ny,1,1)
!              CALL getssh(nx,ny,nl,kapref,pref,thbase,thref,msk3d(:,:,1),f3(:,:,:,2),f3(:,:,:,1),athk,fden-thbase,fpba,fpsikk,fthkk,fmgp,assh)
!              call ncfldio("assh.nc",mlon(:,1),mlat(1,:),mlayer,stime(1),assh,"assh","ssh increments","m",nx,ny,1,1)


              ! project velocities
              if(l3sla) then
               call project_svel(nx,ny,nl,mdepth,si3(:,:,1,1),si3(:,:,2,1),fuvl,fvvl,fpin)
              else
              fuvl=0.0
              fvvl=0.0
              endif        
              call post()



              fthk=athk-fthk
              where(abs(fthk)<onem)fthk=0.0
              ftem=f3(:,:,:,1)-ftem
              fsal=f3(:,:,:,2)-fsal

             if(c2r==1) then
              call r2cxi(XAFileName,nx,ny,nl,mlon,mlat,mlayer,mdepth,sla_inc,fuvl,fvvl,fthk,ftem,fsal)
             else
              call writeHYCOMXI(XAFileName,nx,ny,nl,mlon,mlat,mlayer,mdepth,sla_inc,fuvl,fvvl,fthk,ftem,fsal)
             endif







end program xmgmrf

