MODULE msstat
USE mkinds
USE mncio
USE mgrid

IMPLICIT NONE

real(r4),allocatable      :: std3d(:,:,:)
real(r4),allocatable      :: std2d(:,:)
character(:),allocatable  :: tsis_stat_file
character(:),allocatable  :: tsis_inov_file
character(len=cl)         :: tsis_stat_location

CONTAINS

subroutine read_stats_location()

      NAMELIST /statsnml/tsis_stat_location

        OPEN(21,FILE='tsis.nlist')
        READ(21,NML=statsnml)
        CLOSE(21)

end subroutine




subroutine init_stat(cdtg,mpfx)
implicit none
character(len=*)           :: cdtg
character(len=*)           :: mpfx

         
        allocate(std3d(nx,ny,1))
        allocate(std2d(nx,ny))


end subroutine        


subroutine getvv(var,varb,k)
implicit none
character(*)           :: var
real(r4)                   :: varb(:,:)
integer(i4)                :: k
real(r4)                   :: vscal
logical(bl)                :: lexist


vscal=0.5

if(var=="lxssh") then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"ssh",std2d)
        !call nciocl(statFile,fid)
        !varb=min(0.125,vscal*std2d)
        !varb=std2d
        !print *, maxval(std2d)
         varb=0.125

elseif(var=="tem" .or. var=="lxsst" .or. var=="l4sst") then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"tem",std3d,[1,1,k],[nx,ny,1])
        !call nciocl(statFile,fid)
        !varb=0.5!min(0.75,vscal*std3d(:,:,1))
        varb=0.5 !vscal*std3d(:,:,1)

elseif(var=="sal") then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"sal",std3d,[1,1,k],[nx,ny,1])
        !call nciocl(statFile,fid)
        !varb=0.1!min(0.15,vscal*std3d(:,:,1))
        varb=0.10!vscal*std3d(:,:,1)

elseif(var=='pin') then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"pin",std3d,[1,1,k],[nx,ny,1])
        !call nciocl(statFile,fid)
        varb=25.0 !vscal*std3d(:,:,1)
elseif(var=="uvl") then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"pin",std3d,[1,1,k],[nx,ny,1])
        !call nciocl(statFile,fid)
        varb=0.5 !min(20.0,vscal*std3d(:,:,1))

else if(var=="vvl") then
        !call nciopn(statFile,fid)
        !call nciorv(statFile,fid,"pin",std3d,[1,1,k],[nx,ny,1])
        !call nciocl(statFile,fid)
        varb=0.5 !min(20.0,vscal*std3d(:,:,1))

endif

end subroutine

end module
