program xa2inc
use mkinds
use mconstants
use mncio
use mgrid
use mdates
use mstring
use mhycom


implicit none


real(r4),allocatable    :: uvl(:,:,:)
real(r4),allocatable     :: vvl(:,:,:)
real(r4),allocatable     :: thk(:,:,:)
real(r4),allocatable     :: tem(:,:,:)
real(r4),allocatable     :: sal(:,:,:)
real(r4),allocatable     :: ssh(:,:)
real(r4),allocatable     :: mld(:,:)
real(r4),allocatable     :: uba(:,:)
real(r4),allocatable     :: vba(:,:)

integer(i4)  :: i,j,k
character(:),allocatable :: inFile
character(24)             :: incupFile
character(10) :: cdtg
real(r4)      :: stime(1)
real(r4)      :: deltat
character(4)                 :: cyear
character(3)                 :: cday
character(2)                 :: chour
character(4)                 :: clevel
integer(i4)                  :: stat
integer(i4)                     :: year
integer(i4)                  :: day
integer(i4)                  :: hour

!!Alex offset 6hours
deltat=0.25 ! day
call get_command_argument(1,cdtg)
write(*,*) cdtg
!call hday2cymd(stime(1),cdtg)
call cymd2hday(cdtg,stime(1))
write(*,*) stime(1)-deltat
call hday2ydnhh(stime(1)-deltat,year,day,hour)
write(cyear(1:4),'(i4.4)') year
write(cday(1:3),'(i3.3)')  day
Write(chour(1:2),'(i2.2)') hour

call initialize_analysis_grid()
write(*,*) 'nx,ny,nl:',nx,ny,nl
allocate(uvl(nx,ny,nl))
allocate(vvl(nx,ny,nl))
allocate(thk(nx,ny,nl))
allocate(tem(nx,ny,nl))
allocate(sal(nx,ny,nl))
allocate(ssh(nx,ny))
allocate(mld(nx,ny))
allocate(uba(nx,ny))
allocate(vba(nx,ny))

uba=0.0
vba=0.0


inFile="inc."//cyear//"_"//cday//"_"//chour//".nc"
call nciopn(inFile,fid)
write(*,*) 'starts now! '
call nciorv(inFile,fid,"uvl",uvl)
write(*,*) 'uvl'
call nciorv(inFile,fid,"vvl",vvl)
write(*,*) 'vvl'
call nciorv(inFile,fid,"thk",thk)
write(*,*) 'thk'
call nciorv(inFile,fid,"tem",tem)
write(*,*) 'tem'
call nciorv(inFile,fid,"sal",sal)
write(*,*) 'sal'
call nciorv(inFile,fid,"ssh",ssh)
write(*,*) 'ssh'
call nciocl(inFile,fid)



    incupFile="incup/incupd."//cyear//"_"//cday//"_"//chour
    call writearchvdiff(incupFile,nx,ny,nl,stime(1)-deltat,thbase,thflag,sigver,mlayer,mdepth,ssh,mld,uba,vba,uvl,vvl,thk,tem,sal)

end program      
